<template>
    <div class="row">
        <div class="col-12 p-0" id="">
            <div id="contenedor-imagen-portada" v-if="PublicacionPortada">
                <img  id="foto-portada" class="h-100 w-100" :src="PublicacionPortada.imagen" alt="" @click="mostrarModalPerfilYPortada(PublicacionPortada)">
                <div class="bg-white p-1" id="contenedor-imagen-perfil" v-if="publicacionPerfil">
                    <img :src="publicacionPerfil.imagen" id="foto-perfil" alt="" @click="mostrarModalPerfilYPortada(publicacionPerfil)">
                </div>
            </div>
        </div>
        <div class="col-12" id="texto">
            <div class="row">
                <div class="col-12 pt-3 d-flex justify-content-between" v-if="PublicacionPortada&&publicacionPerfil&&publicaciones">
                    <h2 class="text-start text-white fw-bold">
                        {{ muro.usuario.nombreUsuario }}
                    </h2>
                    <EditarMuro :user="user" :muro="muro" :publicacionPerfilActual="publicacionPerfil" :publicacionPortadaActual="PublicacionPortada" :publicacionesEntrada="publicaciones" />
                </div>
                <div class="col-12 p-3 text-white">
                    <div class="row text-start">
                        <div class="col-12">
                            <h4>Biografia</h4>
                        </div>
                        <div class="col-12" id="biografia">
                            
                            <p>
                                {{muro.descripcion}}
                            <br>
                            <span class="text-dark-emphasis">
                                {{muro.lugarNacimiento}}
                            </span>
                            </p>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
<!--modal -->
    <div id="modal-foto-perfil-portada">
        <div class="container-fluid h-100" id="contenido-modal-foto-perfil-portada">
            <div id="boton-cerrar-modal-perfil-portada" @click="ocultarModalPerfilYPortada">X</div>
            <div class="row h-100"> 
                <div class="col-12 h-100">
                    <div class="row h-100 p-3" >
                        <div class="col-12 h-100" id="contenedor-foto-perfil-portada-modal" v-if="publicacionEnVista">
                            <img :src="publicacionEnVista.imagen">
                            <div class="container-fluid" id="modal-foto-perfil-portada-texto">
                                <div class="row">
                                    <div class="col-12">
                                        <p></p>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import EditarMuro from './EditarMuro.vue'
import axios from 'axios'
import {buscarImagenPubli} from "@/Services/muro/MuroService.js"
export default {
    name:"InfoPersonal",
    components:{
        EditarMuro
    },
    data(){
        return{
            PublicacionPortada:null,
            publicacionPerfil:null,
            publicacionEnVista:null
        }
    },
    props:{
        muro:{

        },
        publicaciones:[],
        user:{}
    },

    methods:{
        mostrarModalPerfilYPortada(publicacion){
            let modal = document.getElementById("modal-foto-perfil-portada");
            let contenido=document.getElementById("contenido-modal-foto-perfil-portada");
            this.publicacionEnVista=publicacion;
            modal.style.display = "block";

            setTimeout(() => {
                modal.style.background = "rgba(0, 0, 0, 0.65)";
                contenido.style.opacity="100%";
                modal.style.setProperty("backdrop-filter", "blur(10px)");
            }, 0);
        },
        ocultarModalPerfilYPortada(){
            let modal=document.getElementById("modal-foto-perfil-portada");
            let contenido=document.getElementById("contenido-modal-foto-perfil-portada");
            modal.style.setProperty("backdrop-filter", "blur(0px)");
            modal.style.background = "rgba(0, 0, 0, 0)";
            contenido.style.opacity="0";

            setTimeout(()=>{
                modal.style.display="none";
            },200)
        },
        async buscarFotoPortada(){
            try{
                if (!this.muro.idFotoPortada){
                    return {
                        id:1,
                        imagen:"https://cecsa.cl/wp-content/uploads/2017/10/CEC-DEPARTAMENTO-DE-CIENCIAS-JURIDICAS-%E2%80%93-UNIVERSIDAD-DE-LA-FRONTERA-03.jpg"
                    }
                }else{
                    const respuesta=await axios.get(`http://localhost:3001/p/publicaciones_id?id_publicacion=${this.muro.idFotoPortada}`);
                    let publicacion= respuesta.data;
                    publicacion.imagen= await buscarImagenPubli(publicacion.imagenes[0]);
                    return publicacion;
                }
                
            }catch(e){
                console.log(e)
                return {
                    id:1,
                    imagen:"https://cecsa.cl/wp-content/uploads/2017/10/CEC-DEPARTAMENTO-DE-CIENCIAS-JURIDICAS-%E2%80%93-UNIVERSIDAD-DE-LA-FRONTERA-03.jpg"
                }
            }
        },
         async buscarFotoPerfil(){
            try{
                if(!this.muro.idFotoPerfil){
                    return {
                        id:1,
                        imagen:"https://www.nicepng.com/png/detail/202-2022264_usuario-annimo-usuario-annimo-user-icon-png-transparent.png"
                    }
                }else{
                    const respuesta=await axios.get(`http://localhost:3001/p/publicaciones_id?id_publicacion=${this.muro.idFotoPerfil}`);
                    let publicacion= respuesta.data;
                    publicacion.imagen= await buscarImagenPubli(publicacion.imagenes[0]);
                    return publicacion;
                }
            }catch(e){
                console.log(e)
                return {
                    id:1,
                    imagen:"https://www.nicepng.com/png/detail/202-2022264_usuario-annimo-usuario-annimo-user-icon-png-transparent.png"
                }
            }
         }
    }
    ,
    async mounted(){
        this.PublicacionPortada=await this.buscarFotoPortada();
        this.publicacionPerfil=await this.buscarFotoPerfil();
    }
}
</script>

<style scoped>
#contenedor-imagen-portada{
    height: 300px;
    position: relative;
}
#contenedor-imagen-perfil{
    position: absolute;
    bottom: -35%;
    left: 30px;
    border-radius: 50%;
}
#foto-perfil{
    border-radius: 50%;
    height: 220px;
    width: 220px;
    object-fit: cover;
    cursor: pointer;
}
#foto-portada{
    object-fit: cover;
    cursor: pointer;
}
#texto{
    padding-top: 100px;
}
#biografia{
    font-size: 14px;
}
/* Modal */
#modal-foto-perfil-portada{
    display: none;
    position: fixed;
    transition: background-color .2s;
    height: 100vh;
    width: 100%;
    top:0;
    left:0;
    z-index: 100;
}
#contenido-modal-foto-perfil-portada{
    opacity: 0;
    transition: opacity .2s;
}
#contenido-modal-foto-perfil-portada img{
    height: 100%;
    width: 100%;
    object-fit: contain;
}
#boton-cerrar-modal-perfil-portada{
    color: white;
    position: fixed;
    margin: 10px;
    width: 50px;
    height: 50px;
    top: 0;
    right: 0;
    z-index: 200;
    cursor: pointer;
}
#contenedor-foto-perfil-portada-modal{
    position: relative;
}
#modal-foto-perfil-portada-texto{
    
    position: absolute;
    color: white;
    text-shadow: 0px 0px 1px black,0px 0px 2px black,0px 0px 3px black,0px 0px 4px black;
    width: 80vw;
    height: auto;
    bottom: 0;
    left: 50%;
    transform: translateX(-50%);
}
</style>